#--*-coding:utf-8-*--

class Dothack < DiceBot
  
  def initialize
    super
    @sendMode = 2
    @sortType = 3;
    @d66Type = 2;
    @defaultSuccessTarget = 0;
  end
  
  def gameName
    '.hack//TRPG 無限増殖'
  end
  
  def gameType
    "Dothack"
  end
  
  def prefixs
    ['RET','IET','QET','OET','RTT','RTI','FT','ET\d+','DET\d+','MT','RT','RI','BUA','BUB','HBA','HBB','TUA','TUB','HAA','HAB','LAA','LAB','WMA','WMB','GRA','GRB',]
  end
  
  def getHelpMessage
    return <<MESSAGETEXT
・ルートタウン
ルートタウンイベント表　　　　RET
　情報系 IET／クエスト系 QET／そのほか OET
ルートタウン表※　　　　　　　RTT
真相表　　　　　　　　　　　　FT
・ダンジョン
イベント表（vol2）　　　　　　ETn
ダンジョンイベント表（vol3）　DETn
（nは現在の部屋数／１０。端数切捨て）
・戦闘
モンスター表　　　　　　　　　MT
戦果表※　　　　　　　　　　　RT
・ＰＣ
剣士　　　BUA/BUB　重剣士　　HBA/HBB
双剣士　　TUA/TUB　重斧使い　HAA/HAB
重槍使い　LAA/LAB　呪紋使い　WMA/WMB
拳闘士　　GRA/GRB　　（vol2/vol3）
※……末尾のTをIに変更で一覧表示（例：RTI → ルートタウン一覧）
MESSAGETEXT
  end
  
  def changeText(string)
    string
  end
  
  def rollDiceCommand(command)
    case command
    when 'RET'
      type = 'ルートタウンイベント表'
      output, total_n, = dothack_roottown_event_table
    when 'IET'
      type = '情報系イベント表'
      output, total_n, = dothack_information_event_table
    when 'QET'
      type = 'クエスト系イベント表'
      output, total_n, = dothack_quest_event_table
    when 'OET'
      type = 'そのほかイベント表'
      output, total_n, = dothack_other_event_table
    when 'RTT'
      type = 'ルートタウン表'
      output, total_n, = dothack_roottown_table
    when 'RTI'
      type = 'ルートタウン一覧'
      output, total_n, = dothack_roottown_index
    when 'FT'
      type = '真相表'
      output, total_n, = dothack_fact_table
    when /DET/i
      type = 'ダンジョンイベント表'
      output, total_n, = dothack_dungeon_event_table(command)
    when /ET/i
      type = 'イベント表'
      output, total_n, = dothack_event_table(command)
    when 'MT'
      type = 'モンスター表'
      output, total_n, = dothack_monster_table
    when 'RT'
      type = '報酬表'
      output, total_n, = dothack_reward_table
    when 'RI'
      type = '報酬一覧'
      output, total_n, = dothack_reward_index
    when 'BUA'
      type = '剣士Ａ'
      output, total_n, = dothack_bladeuser_a_table
    when 'BUB'
      type = '剣士Ｂ'
      output, total_n, = dothack_bladeuser_b_table
    when 'HBA'
      type = '重剣士Ａ'
      output, total_n, = dothack_heavyblade_a_table
    when 'HBB'
      type = '重剣士Ｂ'
      output, total_n, = dothack_heavyblade_b_table
    when 'TUA'
      type = '双剣士Ａ'
      output, total_n, = dothack_twinuser_a_table
    when 'TUB'
      type = '双剣士Ｂ'
      output, total_n, = dothack_twinuser_b_table
    when 'HAA'
      type = '重斧使いＡ'
      output, total_n, = dothack_heavyax_a_table
    when 'HAB'
      type = '重斧使いＢ'
      output, total_n, = dothack_heavyax_b_table
    when 'LAA'
      type = '重槍使いＡ'
      output, total_n, = dothack_longarm_a_table
    when 'LAB'
      type = '重槍使いＢ'
      output, total_n, = dothack_longarm_b_table
    when 'WMA'
      type = '呪紋使いＡ'
      output, total_n, = dothack_wavemaster_a_table
    when 'WMB'
      type = '呪紋使いＢ'
      output, total_n, = dothack_wavemaster_b_table
    when 'GRA'
      type = '拳闘士Ａ'
      output, total_n, = dothack_grappler_a_table
    when 'GRB'
      type = '拳闘士Ｂ'
      output, total_n, = dothack_grappler_b_table
    end
    return "#{type}(#{total_n}) → #{output}"
  end

  def dothack_roottown_event_table
    outtext = ""
    outnum = ''
    num, dummy = roll(1, 6)
    if num <= 2
      outtext, outnum = dothack_information_event_table
      outtext = "情報系イベント表(#{outnum}) → #{outtext}"
    elsif num <= 4
      outtext, outnum = dothack_quest_event_table
      outtext = "クエスト系イベント表(#{outnum}) → #{outtext}"
    else
      outtext, outnum = dothack_other_event_table
      outtext = "そのほかイベント表(#{outnum}) → #{outtext}"
    end
    outnum = num
    return outtext, outnum
  end
  
  def dothack_information_event_table
    table = [
               '『腕の立つＰＣの噂を聞いた』そのＰＣは、あなたの欲しい「謎」のレアアイテムを持っているという噂だ。難易度８の探索判定を行うことができる。キーワードは「ＰＣ」。',
               '『見たこともないモンスターに襲われる』「謎」のモンスターから、間一髪で逃げ切ることができた。難易度８の探索判定を行うことができる。キーワードは「モンスター」。',
               '『レアアイテムがあるという』「謎」のダンジョンがある限定エリアの噂を聞いた。難易度８の探索判定を行うことができる。キーワードは「アイテム」。',
               '『異性の形をした放浪ＡＩに出会う』「謎」の言葉を残し、放浪ＡＩは去った。難易度８の探索判定を行うことができる。キーワードは「伝説」。',
               '『あなたと同じＰＣモデルが……』あちこちでＰＫをしているという「謎」の噂。難易度８の探索判定を行うことができる。キーワードは「悪い噂」。',
               '『謎のメールが届く』「あなたのことが好きだ」と名乗る「謎」の人物からメールが来る。その正体は……？　難易度８の探索判定を行うことができる。キーワードは「プレイヤー」。',
               ]
    return get_table_by_1d6(table)
  end
  
  def dothack_quest_event_table
    table = [
               '『有名ＰＣにお願いされる』ダンジョンの中にいるガーディアンを倒してほしいと頼まれる。どのダンジョンでもいいので、ガーディアンを倒した後、ルートタウンに帰れば、有名人の武器をもらうことができる。',
               '『パーティーの仲間にお願いされる』ＰＣを１人選ぶ。そのＰＣには、そのダンジョンを攻略しなければいけない理由があった（理由は設定に合わせてみんなで考えること）。Λサーバにあるダンジョンに挑むこと。クリアすれば、思い出の逸品を手に入れる。',
               '『放浪ＡＩにお願いされる』Λサーバのダンジョンの中のボスに大切なアイテムを奪われた。それを取り戻してほしいと依頼される。そのダンジョンの最後の部屋に必ず「ブレス」のスキルを習得したモンスターが登場する。そのモンスターを倒すと、マスコットを手に入れるか、レア設定を【腕輪保持者】に変更してもらえる。',
               '『システム管理者にお願いされる』ダンジョン内にいるウィルスバグを倒して欲しいといわれる。どのダンジョンでもいいので、ウィルスバグを倒した後、ルートタウンに帰れば、好きなレアアイテムを１個もらうか、レア設定を【碧衣の騎士団】に変更してもらえる。',
               '『リアルの友人にお願いされる』リアルの友人の好きな人が『The world』の中にＰＣとしているらしい。その人のことを調べて欲しいと頼まれる。難易度９の探索判定を行うこと。キーワードは「プレイヤー」。謎を解明すれば、そのＰＣからお礼に金のプチグソをもらうことができる。',
               '『ネットスラムの住人からお願いされる』ネットスラムの住人にスラムに住みついたモンスターを退治してほしいと頼まれる。サイコロを２回振ってモンスターを２種類決定し、戦闘開始だ。このモンスターからは逃走できない。モンスターを両方倒すと、チートアイテムか碑文の断片を手に入れる。',
               ]
    outtext,outnum = get_table_by_1d6(table)
    if outnum == 6
      2.times do
        montext,monnum = dothack_monster_table
        montext = "#{outtext}\nモンスター表(#{monnum}) → #{montext}"
      end
      outtext = montext
    end
    return outtext,outnum
  end
  
  def dothack_other_event_table
    table = [
               '『恋の予感！』仲間がかっこよく見える。ＰＣを１人選んで、その相手に対して片想いになる。',
               '『トレード大会開催！』自分の持っているレアアイテムを好きなレアアイテムと交換してもらえる。',
               '『ネットスラムへ移動！』なぜかネットスラムへ迷い込んでしまう。そのＰＣは、このルートタウンパートでは、ダンジョン以外に移動できなくなる。',
               '『いいことあった』ルートタウンに到着早々、いいことがあった。報酬表を１回振る。',
               '『季節限定イベント』その季節限定の特殊なイベント。難易度６の探索判定に成功すれば、スクール水着を手に入れることができる。',
               '『モンスターが街に侵入!?』モンスターが現われる。サイコロを振ってモンスターを決定し、戦闘開始だ。このモンスターのトドメをさしたターンに、一番高いダメージを出したＰＣは、ホームをもらうか、【レア設定】をカリスマに変更することができる。',
               ]
    outtext,outnum = get_table_by_1d6(table)
    if outnum == 4
      rewtext,rewnum = dothack_reward_table
      rewtext = "#{outtext}\n報酬表(#{rewnum}) → #{rewtext}"
      outtext = rewtext
    elsif outnum == 6
      montext,monnum = dothack_monster_table
      montext = "#{outtext}\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    end
    return outtext,outnum
  end
  
  def dothack_roottown_table
    table = [
             'Δ水の都 マク・アヌ\nキーワード：「ＰＣ」\nハプニング：紅衣の騎士団に因縁をつけられる。サイコロを１個振り、その目と同じ数の見習いバルキリーとの戦闘になる。探索判定に参加していないＰＣも、次のターンからかけつけることができる。',
             'Θ高山都市 ドゥナ・ロリヤック\nキーワード：「モンスター」\nハプニング：開催中のプチグソレースに巻き込まれる！　この探索判定に参加したＰＣに【プチグソ使い】がいなければ、全員２０ダメージを受ける。',
             'Λ文明都市 カルミナ・ガデリカ\nキーワード：「アイテム」\nハプニング：持ち物をスられてしまう。この探索判定に参加したＰＣが持っているアイテムの中から１つランダムに選んで、それが盗まれる。',
             'Σ空中都市 フォート・アウフ\nキーワード：「伝説」\nハプニング：上級者ＰＣと決闘することになる。探索判定に参加していたＰＣの中から１人選ぶ。そのＰＣとグラディエーター１体と戦闘をすること。',
             'Ω遺跡都市 リア・ファイル\nキーワード：「悪い噂」\nハプニング：ネットスラムへ移動！　この探索判定に参加したＰＣは、このルートタウンパートでは、ネットスラムから他のルートタウンへ移動できなくなる（ダンジョンへは移動できる）。',
             '幻の都 ネーベル・モント\nキーワード：「プレイヤー」\nハプニング：見知らぬＰＣと仲良くなって、喧嘩をしてしまう。その探索判定に参加していたＰＣの中に恋人や片思いのＰＣがいた場合、その関係が解消される。',
            ]
      return get_table_by_1d6(table)
  end
  
  def dothack_roottown_index
    outtext = "
Δ水の都 マク・アヌ\nキーワード：「ＰＣ」\nハプニング：紅衣の騎士団に因縁をつけられる。サイコロを１個振り、その目と同じ数の見習いバルキリーとの戦闘になる。探索判定に参加していないＰＣも、次のターンからかけつけることができる。
Θ高山都市 ドゥナ・ロリヤック\nキーワード：「モンスター」\nハプニング：開催中のプチグソレースに巻き込まれる！　この探索判定に参加したＰＣに【プチグソ使い】がいなければ、全員２０ダメージを受ける。
Λ文明都市 カルミナ・ガデリカ\nキーワード：「アイテム」\nハプニング：持ち物をスられてしまう。この探索判定に参加したＰＣが持っているアイテムの中から１つランダムに選んで、それが盗まれる。
Σ空中都市 フォート・アウフ\nキーワード：「伝説」\nハプニング：上級者ＰＣと決闘することになる。探索判定に参加していたＰＣの中から１人選ぶ。そのＰＣとグラディエーター１体と戦闘をすること。
Ω遺跡都市 リア・ファイル\nキーワード：「悪い噂」\nハプニング：ネットスラムへ移動！　この探索判定に参加したＰＣは、このルートタウンパートでは、ネットスラムから他のルートタウンへ移動できなくなる（ダンジョンへは移動できる）。
・幻の都 ネーベル・モント\nキーワード：「プレイヤー」\nハプニング：見知らぬＰＣと仲良くなって、喧嘩をしてしまう。その探索判定に参加していたＰＣの中に恋人や片思いのＰＣがいた場合、その関係が解消される。
・ネットスラム\nキーワード：なし\nハプニング：データの海に飲み込まれる。この探索判定に参加したＰＣは、レア設定が【未帰還者】に変更されてしまう。"
    outnum = 'index'
    return outtext,outnum
  end
  
  def dothack_fact_table
    table = [
             '『真相解明！』なるほど、そういうことだったのか!?　あなたの出会った「謎」を解明し、そこでかけがえのない何かを手に入れることになった。好きなレアアイテムを１つ手に入れる。',
             '『「謎」の答えは実は……』パーティの誰かが知っているらしい。しかし、今はまだそれを教えてくれるほど、心を開いていない。ランダムにパーティの１人を選ぶ。彼と何らかの関係を結べば、「謎」が解明され、好きなレアアイテムを１個手に入れる。',
             '『真相はダンジョンの中に……』ダンジョンの奥にありそうだ。ダンジョンを最後までクリアすれば、「謎」を解明し、好きなレアアイテムを１個手に入れることができる。',
             '『知ってるヤツなら別の街に……』「謎」の答えは別の街にあるみたいだ。今いるのとは別の街でもう一度、難易度８の情報判定を行うことができる。',
             '『交換条件だ』そのことを知っているヤツを教えてくれるという人物が現われた。しかし、教えるためには、レアアイテムと交換だという。レアアイテムを１個手放せば、もう一度真相表を振ることができる。',
             '『くっ、罠か！？』それはきみたちをおびき出す罠だった。モンスターが２種類現われる。サイコロを２回振ってモンスターを２種類決定し、戦闘開始だ。このモンスターからは逃走できない。',
            ]
    outtext,outnum = get_table_by_1d6(table)
    if outnum == 6
      montext,monnum = dothack_monster_table
      montext = "#{outtext}\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    end
    return outtext,outnum
  end
  
  def dothack_event_table(command)
    return '' unless( /^ET(\d+)$/ =~ command )
    floor = $1.to_i
    outtext = ""
    outnum = ''
    hoge, dummy = roll(2, 6)
    num = hoge+floor
    if num == 2
      outtext = "『ジメジメした通路』特に何もなし。スキルに【リプス】か【ラリプス】、【リプメイン】を持つキャラクターがいれば、ＳＰを１０消費して使用できる。"
    elsif num == 3
      outtext = "『プチグソの餌があった』もしも、レア設定に「プチグソ使い」を選んだＰＣがいたら、そのＰＣのＨＰを３０点回復する。"
    elsif num == 4
      outtext = "『喧嘩しちゃった』パーティ全員の友好度が－１０。"
    elsif num == 5
      rewtext,rewnum = dothack_reward_table
      montext = "『宝箱があった！』報酬表を１回振る。\n報酬表(#{rewnum}) → #{rewtext}"
      outtext = montext
    elsif num == 6 || num == 7 || num == 10
      montext,monnum = dothack_monster_table
      montext = "『魔法陣があらわれたっ！』逃走するなら、ＰＣは全員サイコロを１個振る。誰か１人でも１の目が出たら、逃走は失敗する。モンスターの攻撃力分だけ、ダメージを受ける。逃走は何度でも、試みることができる。戦闘するか、逃走に失敗したら、モンスターが現われる。サイコロを振ってモンスターを決定して、戦闘開始だ。\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    elsif num == 8
      outtext = "『罠だ！』代表で１人、サイコロを振ること。６の目が出たら、報酬表を１回振れる。"
    elsif num == 9
      outtext = "『あれれ、迷っちゃった』ＰＣは全員サイコロを１個振る。誰か１人でも１の目が出たら、サイコロ１個分、部屋の数が増える。"
    elsif num == 11
      outtext = "『オブジェクト発見』代表で１人、サイコロを振ること。６の目が出たら、報酬表を１回振れる。"
    elsif num == 12 || num == 13
      montext,monnum = dothack_monster_table
      montext = "『魔法陣オープン！』モンスターが現われる。サイコロを振ってモンスターを決定し、戦闘開始だ。\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    elsif num == 14
      outtext = "『不気味な静寂……』特に何もなし。スキルに【リプス】か【ラリプス】、【リプメイン】を持つキャラクターがいれば、ＳＰを１０消費して使用できる。"
    elsif num == 16
      outtext = "『気になるあいつ』友好度が５０を超えている異性のキャラクターがいれば、そのキャラクターに恋心を抱く。友好度とＳＰが＋２０。"
    else #15,17over
      montext,monnum = dothack_monster_table
      montext = "『ウィルスバグに遭遇！』サイコロを振ってモンスターを決定し、戦闘開始だ！　このモンスターはウィルスバグ化しているので、【データドレイン】を使わないと倒せず、攻撃力が＋２０されている。逃走するなら、ＰＣは全員サイコロを１個振る。誰か１人でも１の目が出たら、逃走は失敗する。モンスターの攻撃力分だけ、ダメージを受ける。逃走は何度でも、試みることができる。ウイルスバグを倒した場合、報酬表を振らず、表の中から好きな結果を１つ選ぶことができる。\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    end
    outnum = "#{hoge}\+#{floor}\=#{num}"
    return outtext, outnum
  end
  
  def dothack_dungeon_event_table(command)
    return '' unless( /^DET(\d+)$/ =~ command )
    floor = $1.to_i
    outtext = ""
    outnum = ''
    hoge, dummy = roll(2, 6)
    num = hoge+floor
    if num == 2
      outtext = "『ジメジメした通路』特に何もなし。スキルに【リプス】か【ラリプス】、【リプメイン】を持つキャラクターがいれば、ＳＰを１０消費して使用できる。"
    elsif num == 3
      outtext = "『プチグソの餌があった』もしも、レア設定に「プチグソ使い」を選んだＰＣがいたら、そのＰＣのＨＰを３０点回復する。"
    elsif num == 4
      outtext = "『喧嘩しちゃった』パーティ全員の友好度が－１０。"
    elsif num == 5
      rewtext,rewnum = dothack_reward_table
      rewtext = "『宝箱があった！』報酬表を１回振る。\n報酬表(#{rewnum}) → #{rewtext}"
      outtext = rewtext
    elsif num == 6 || num == 7 || num == 10
      montext,monnum = dothack_monster_table
      montext = "『魔法陣があらわれたっ！』逃走するなら、ＰＣは全員サイコロを１個振る。誰か１人でも１の目が出たら、逃走は失敗する。モンスターの攻撃力分だけ、ダメージを受ける。逃走は何度でも、試みることができる。戦闘するか、逃走に失敗したら、モンスターが現われる。サイコロを振ってモンスターを決定して、戦闘開始だ。\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    elsif num == 8
      outtext = "『罠だ！』難易度５＋現在の部屋数÷１０（切り捨て）の探索判定を行う。失敗した場合、探索判定に参加したもの全員に１０ダメージ。"
    elsif num == 9
      outtext = "『あれれ、迷っちゃった』難易度７＋現在の部屋数÷１０（切り捨て）の探索判定を行う。失敗したら、サイコロを１個振り、その値だけ部屋の数が増える。"
    elsif num == 11
      outtext = "『オブジェクト発見』難易度７＋現在の部屋数÷１０（切り捨て）の探索判定を行う。成功したら、金のプチグソを手に入れる。"
    elsif num == 14
      outtext = "『不気味な静寂……』特に何もなし。スキルに【リプス】か【ラリプス】、【リプメイン】を持つキャラクターがいれば、ＳＰを１０消費して使用できる。"
    elsif num == 15
      outtext = "友好度が５０以上になっている片想いの相手がいた場合、告白しなければいけない。相手が受け入れれば、友好度を減少して恋人の関係になること。"
    elsif num == 16
      outtext = "『アイテム神像を発見』難易度１０＋現在の部屋数÷１０（切り捨て）の探索判定を行う。成功したら、好きなレアアイテムを１個手に入れる。"
    elsif num == 17
      montext,monnum = dothack_monster_table
      montext = "『ウィルスバグに遭遇！』サイコロを振ってモンスターを決定し、戦闘開始だ！　このモンスターはウィルスバグ化しているので、【データドレイン】を使わないとＨＰを５０以下にできないぞ。逃走するなら、ＰＣは全員サイコロを１個振る。誰か１人でも１の目が出たら、逃走は失敗する。モンスターの攻撃力分だけ、ダメージを受ける。逃走は何度でも、試みることができる。\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    elsif num == 18
      outtext = "『他のパーティーがいるぞ』何かアイテムを渡すと、【リプス】か【ラリプス】、【リプメイン】を１回使ってくれる。"
    else #12,13,19over
      montext,monnum = dothack_monster_table
      montext = "『魔法陣オープン！』モンスターが現われる。サイコロを振ってモンスターを決定し、戦闘開始だ。\nモンスター表(#{monnum}) → #{montext}"
      outtext = montext
    end
    outnum = "#{hoge}\+#{floor}\=#{num}"
    return outtext, outnum
  end
  
  def dothack_monster_table
    table = [
             "≪ガーディアン≫\n属性：地／ＨＰ：５３０／攻撃力：５０\n備考：ＨＰが１００以下になると攻撃力が２０アップ。\n出現数：",
             "≪さまよう骨≫\n属性：闇／ＨＰ：２００／攻撃力：２０\n備考：どちらかが死んでいるときに、ＰＣの攻撃が失敗したら、死んだ≪さまよう骨≫がＨＰ全回復して復活する。\n出現数：",
             "≪ヘビグソニアン≫\n属性：火／ＨＰ：１２０／攻撃力：４０\n出現数：",
             "≪見習いバルキリー≫\n属性：木／ＨＰ：９０／攻撃力：２０\n出現数：",
             "≪スカイフィッシュ≫\n属性：水／ＨＰ：９０／攻撃力：２０\n出現数：",
             "≪パラパラナイフ≫\n属性：無／ＨＰ：６０／攻撃力：１０\n出現数：",
             "≪カカシンガー≫\n属性：地／ＨＰ：５０／攻撃力：１０\n出現数：",
             "≪ホットウィッチ≫\n属性：火／ＨＰ：２４０／攻撃力：３０\n出現数：",
             "≪しゃれこうべ≫\n属性：闇／ＨＰ：５０／攻撃力：１０\n出現数：",
             "≪グラディエーター≫\n属性：雷／ＨＰ：２５０／攻撃力：３０\n出現数：",
             "≪ミミック≫\n属性：雷／ＨＰ：３７０／攻撃力：７０\n出現数：",
             ]
      text,outnum = get_table_by_2d6(table)
      if outnum == 2 || outnum == 12
        text = "#{text}1体"
      elsif outnum == 3
        text = "#{text}2体"
      elsif outnum == 4 || outnum == 9 ||outnum == 11
        piyo, dummy  = roll(1,2)
        text = "#{text}1d2 → #{piyo}体"
      elsif outnum == 5 || outnum == 6 
        piyo, dummy = roll(1,3)
        text = "#{text}1d3 → #{piyo}体"
      elsif outnum == 7 || outnum == 10 
        piyo, dummy = roll(1,6)
        text = "#{text}1d6 → #{piyo}体"
      else
        piyo, dummy = roll(1,6)
        piyo = piyo+1
        text = "#{text}1d6\+1 → #{piyo}体"
      end
      outtext = text
      return outtext,outnum
  end
  
  def dothack_reward_table
    table = [
             '『みんなの絆が深まった！』全員の友好度が１０アップする。',
             '『お札を手に入れた！』誰かがサイコロを振ったとき、その目を±１することができる。使うとなくなる。',
             '『気魂を手に入れた！』ＰＣ１人のＳＰを４０回復する。使うとなくなる。',
             '『蘇生の秘薬を手に入れた！』ＰＣ１人のゴースト状態を回復する。使うとなくなる。',
             '『癒しの水を手に入れた！』ＰＣ１人のＨＰを４０回復する。使うとなくなる。',
             '『完治の水を手に入れた！』ＰＣ１人のＨＰを全回復する。使うとなくなる。',
            ]    
      return get_table_by_1d6(table)
  end
  
  def dothack_reward_index
    outtext = "
1:『みんなの絆が深まった！』全員の友好度が１０アップする。
2:『お札を手に入れた！』誰かがサイコロを振ったとき、その目を±１することができる。使うとなくなる。
3:『気魂を手に入れた！』ＰＣ１人のＳＰを４０回復する。使うとなくなる。
4:『蘇生の秘薬を手に入れた！』ＰＣ１人のゴースト状態を回復する。使うとなくなる。
5:『癒しの水を手に入れた！』ＰＣ１人のＨＰを４０回復する。使うとなくなる。
6:『完治の水を手に入れた！』ＰＣ１人のＨＰを全回復する。使うとなくなる。"
    outnum = 'index'
    return outtext,outnum
  end
  
  def dothack_bladeuser_a_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【クロススラッシュ】モンスター１体に５０ダメージ。',
               '４０ダメージ or 【アプドゥ】自分以外のＰＣが振ったサイコロを振り直す。',
               '５０ダメージ or 【リボルバー】モンスター全体に４０ダメージ。',
               '６０ダメージ or 【アンリボルバー】モンスター全体に５０ダメージ。そのモンスターが雷属性なら、１００ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_bladeuser_b_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【クロススラッシュ】モンスター１体に５０ダメージ。',
               '４０ダメージ or 【アプトープ】自分以外のＰＣが１を出した者全員、サイコロを振り直すことができる。',
               '５０ダメージ or 【リボルバー】モンスター全体に４０ダメージ。',
               '６０ダメージ or 【バクリボルバー】モンスター全体に５０ダメージ。そのモンスターが水属性なら、１００ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_heavyblade_a_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【反隼】ＨＰが５０点以下のモンスター１体を破壊する。',
               '４０ダメージ or 【アプコープ】この戦闘中、自分以外のＰＣ１人のダメージが＋２０される。この効果は累積しない。',
               '５０ダメージ or 【火麟】モンスター全体に４０ダメージ。そのモンスターが水属性なら、８０ダメージ。',
               '６０ダメージ or 【雷焔】モンスター１体に８０ダメージ。そのモンスターが闇属性なら、１５０ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_heavyblade_b_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【デスブリング】ＨＰが５０点以下のモンスター１体を破壊する。',
               '４０ダメージ or 【アプコープ】この戦闘中、自分以外のＰＣ１人のダメージが＋２０される。この効果は累積しない。',
               '５０ダメージ or 【ガンドライブ】モンスター１体に８０ダメージ。そのモンスターが木属性なら、１５０ダメージ。',
               '６０ダメージ or 【ディバイダー】モンスター１体のＨＰを現在の半分にする（切り上げ）。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_twinuser_a_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【舞武】モンスター１体に３０ダメージ。',
               '４０ダメージ or 【リプス】ＰＣ１人のＨＰを３０点回復する。',
               '５０ダメージ or 【気魂】自分以外のＰＣのＳＰを４０回復する。',
               '６０ダメージ or 【雷独楽】モンスター全体に４０ダメージ。そのモンスターが闇属性なら、８０ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_twinuser_b_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【舞武】モンスター１体に３０ダメージ。',
               '４０ダメージ or 【リプス】ＰＣ１人のＨＰを３０点回復する。',
               '５０ダメージ or 【リプメイン】ゴースト状態のＰＣ１人をＨＰ全回復状態で蘇らせる。',
               '６０ダメージ or 【邪舞】モンスター単体に７０ダメージ。そのモンスターが雷属性なら１４０ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_heavyax_a_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【アクセルペイン】自分の振ったサイコロを振り直す',
               '４０ダメージ or 【グランドアーマー】この戦闘中、モンスターの攻撃力を０にする。',
               '５０ダメージ or 【ガンブレイク】モンスター全体に４０ダメージ。そのモンスターが木属性なら、８０ダメージ。',
               '６０ダメージ or 【アンバッシャー】モンスター全体に６０ダメージ。そのモンスターが雷属性なら、１００ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_heavyax_b_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【アクセルペイン】自分の振ったサイコロを振り直す',
               '４０ダメージ or 【闘士の血】ＰＣを１人選ぶ。この戦闘中、そのＰＣが受けるダメージが－１０される。この効果は累積しない。',
               '５０ダメージ or 【リウブレイク】モンスター全体に３０ダメージ。そのモンスターが水属性なら、１００ダメージ。',
               '６０ダメージ or 【ライオパニッシュ】モンスター全体に６０ダメージ。そのモンスターが闇属性なら、１００ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_longarm_a_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【トリプルドゥーム】ＰＣ全員の振ったサイコロを振り直す',
               '４０ダメージ or 【ダブルスイープ】モンスター全体に３０ダメージ。',
               '５０ダメージ or 【ドレインスキル】モンスター１体に２０ダメージを与え、自分のＨＰを２０回復する。',
               '６０ダメージ or 【ジュワイプアウト】モンスター全体に５０ダメージ。そのモンスターが地属性なら、１００ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_longarm_b_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【トリプルドゥーム】ＰＣ全員の振ったサイコロを振り直す。',
               '４０ダメージ or 【バクドゥーム】モンスター１体に４０ダメージ。そのモンスターが水属性なら、８０ダメージ。',
               '５０ダメージ or 【ドレインスキル】モンスター１体に２０ダメージを与え、自分のＨＰを２０回復する。',
               '６０ダメージ or 【ジュワイプアウト】モンスター全体に５０ダメージ。そのモンスターが地属性なら、１００ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_wavemaster_a_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【ジュクルズ】モンスター１体に５０ダメージ。',
               '４０ダメージ or 【ジュローム】モンスター全体に３０ダメージ。',
               '５０ダメージ or 【ラリプス】ＰＣ全員のＨＰを５０点回復。',
               '６０ダメージ or 【リプメイン】ゴースト状態のＰＣ１人を全回復状態で蘇生する。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_wavemaster_b_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【アンクルズ】モンスター１体に２０ダメージ。そのモンスターが雷属性なら、５０ダメージ。',
               '４０ダメージ or 【メリウゾット】モンスター全体に３０ダメージ。そのモンスターが火属性なら、６０ダメージ。',
               '５０ダメージ or 【ラリプス】ＰＣ全員のＨＰを５０点回復。',
               '６０ダメージ or 【リプメイン】ゴースト状態のＰＣ１人を全回復状態で蘇生する。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_grappler_a_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【軽踊脚（ファンキーストンプ）】この戦闘中、受けるダメージが－１０される。この効果は累積しない。',
               '４０ダメージ or 【空手斬（カラテチョップ）】この戦闘中、自分のダメージが＋２０される。この効果は累積しない。',
               '５０ダメージ or 【破壊律（ブレイクビート）】モンスター１体のＨＰを半分にする（切り上げ）。',
               '６０ダメージ or 【拳舞（ナックルオペラ）】モンスター全体に７０ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  def dothack_grappler_b_table
    table = [
               '失敗！',
               '２０ダメージ or レア設定スキル',
               '３０ダメージ or 【医龍（メディカルドラゴン）】気魂、蘇生の秘薬、癒しの水、完治の水を１つ消費すれば、ＰＣ２人にその効果を与える。',
               '４０ダメージ or 【空手斬（カラテチョップ）】この戦闘中、自分のダメージが＋２０される。この効果は累積しない。',
               '５０ダメージ or 【黒気（ブラックオーラ）】モンスター１体のＨＰを最大値の半分にする（切り上げ）。',
               '６０ダメージ or 【拳舞（ナックルオペラ）】モンスター全体に７０ダメージ。',
               ]
    return get_table_by_1d6(table)
  end
  
  # ゲーム別成功度判定(nD6)
  def check_nD6(total_n, dice_n, signOfInequality, diff, dice_cnt, dice_max, n1, n_max)
    return '' unless( signOfInequality == ">=")    
    if(dice_n == 1)
      return " → 失敗！"
    else
      return ""
    end
  end
end
